---
title: AudioBufferSourceNode.loopStart
slug: Web/API/AudioBufferSourceNode/loopStart
tags:
  - API
  - Audio
  - AudioBufferSourceNode
  - Media
  - Property
  - Reference
  - Web Audio API
  - loopStart
  - sound
---
<p>{{ APIRef("Web Audio API") }}</p>

<p>The <strong><code>loopStart</code></strong> property of the {{ domxref("AudioBufferSourceNode") }} interface is a floating-point value indicating, in seconds, where in the {{domxref("AudioBuffer")}} the restart of the play must happen.</p>

<p>The <code>loopStart</code> property's default value is <code>0</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>AudioBufferSourceNode.loopStart = startOffsetInSeconds</em>;

<em>startOffsetInSeconds</em> = <em>AudioBufferSourceNode.loopStart</em>;
</pre>

<h3 id="Value">Value</h3>

<p>A floating-point number indicating the offset, in seconds, into the audio buffer at which each loop should begin during playback. This value is only used when the {{domxref("AudioBufferSourceNode.loop", "loop")}} parameter is <code>true</code>.</p>

<h2 id="Example">Example</h2>

<p>In this example, the {{domxref("AudioContext.decodeAudioData()")}} function is used to decode an audio track and put it into an {{domxref("AudioBufferSourceNode")}}. Buttons are provided to play and stop the audio playback, and slider controls are used to change the <code>playbackRate</code>, <code>loopStart</code>, and <code>loopEnd</code> properties on the fly.</p>

<p>When the audio is played to the end, it loops, but you can control how long the loops last by altering <code>loopStart</code> and <code>loopEnd</code>. For example, if you set their values to 20 and 25, respectively, the audio will start to loop between 20 and 25 seconds in to the track.</p>

<div class="note">
<p>For a full working example, see <a class="external external-icon" href="https://mdn.github.io/webaudio-examples/decode-audio-data/">this code running live</a>, or <a class="external external-icon" href="https://github.com/mdn/webaudio-examples/tree/master/decode-audio-data">view the source</a>.</p>
</div>

<pre class="brush: js">function getData() {
  source = audioCtx.createBufferSource();
  request = new XMLHttpRequest();

  request.open('GET', 'viper.ogg', true);
  request.responseType = 'arraybuffer';

  request.onload = function() {
    var audioData = request.response;

    audioCtx.decodeAudioData(audioData, function(buffer) {
        myBuffer = buffer;
        songLength = buffer.duration;
        source.buffer = myBuffer;
        source.playbackRate.value = playbackControl.value;
        source.connect(audioCtx.destination);
        source.loop = true;

        loopstartControl.setAttribute('max', Math.floor(songLength));
        loopendControl.setAttribute('max', Math.floor(songLength));
      },

      function(e){"Error with decoding audio data" + e.err});

  }

  request.send();
}

  ...

loopstartControl.oninput = function() {
  source.loopStart = loopstartControl.value;
  loopstartValue.innerHTML = loopstartControl.value;
}

loopendControl.oninput = function() {
  source.loopEnd = loopendControl.value;
  loopendValue.innerHTML = loopendControl.value;
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audiobuffersourcenode-loopstart', 'loopStart')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioBufferSourceNode.loopStart")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
